(MODULE TOOL1LIB-MOST)
;;; LaHaShem HaAretz U'Mloah

(include "QobiScheme.sch")
(include "tool1lib-most.sch")
(include "c-externals.sc")

;;; begin need change

;;; Parameters

(define *hue-stretch* 10)
(define *saturation-stretch* 5)
(define *value-stretch* 10)

;;; end need change

;;; Variables

(define *width* 640)			;needs work: should set from video file

(define *height* 480)			;needs work: should set from video file

(define *point* #f)

(define *mark* #f)

(define *first-line* #f)

(define *mode* #f)

;;; Procedures

(define (separation x y)
 (radians->degrees
  (angle-separation (degrees->radians x) (degrees->radians y))))

(define (hue-mu hues)
 (let* ((mu (radians->degrees (mean-angle (map degrees->radians hues))))
	(mu (inexact->exact (round (if (negative? mu) (+ mu 360.0) mu)))))
  (if (= mu 360) 0 mu)))

(define (mu x)
 (k*v (/ (length x)) (reduce v+ x (make-vector (vector-length (first x)) 0))))

(define (sigma x)
 (let ((mu (mu x)))
  (k*m (/ (length x))
       (reduce
	m+
	(map (lambda (x) (self-outer-product * (v- x mu))) x)
	(make-matrix (vector-length (first x)) (vector-length (first x)) 0)))))

(define (pnm->ppm pnm)
 (cond ((ppm? pnm) pnm)
       ((pgm? pnm) (pgm->ppm pnm))
       ((pbm? pnm) (pbm->ppm pnm))
       (else (fuck-up))))

(define (pnm->pgm pnm)
 (cond ((ppm? pnm) (ppm->pgm pnm))
       ((pgm? pnm) pnm)
       ((pbm? pnm) (pbm->pgm pnm))
       (else (fuck-up))))

(define (pnm->pgm-edges pnm sigma a1 a2 t1 t2 l w)
 (let* ((pgm (if (zero? sigma)
		 (pnm->pgm pnm)
		 (pgm-gaussian-smooth (pnm->pgm pnm) sigma)))
	(viff (create-image (pnm-height pgm) (pnm-width pgm))))
  (do ((y 0 (+ y 1))) ((>= y (pnm-height pgm)))
   (do ((x 0 (+ x 1))) ((>= x (pnm-width pgm)))
    (viff-set-pixel! viff y x (matrix-ref (pgm-grey pgm) y x))))
  (detect-edges! a1 a2 t1 t2 l w viff)
  (let ((grey (make-matrix (pnm-height pgm) (pnm-width pgm))))
   (do ((y 0 (+ y 1))) ((>= y (pnm-height pgm)))
    (do ((x 0 (+ x 1))) ((>= x (pnm-width pgm)))
     (matrix-set! grey y x (edge-pixel viff y x))))
   (free-xvimage! viff)
   (make-pgm (pgm-raw? pgm) (pgm-maxval pgm) grey))))

(define (pnm->pgm-line-segments pnm sigma a1 a2 t1 t2 l w)
 (let* ((pgm (if (zero? sigma)
		 (pnm->pgm pnm)
		 (pgm-gaussian-smooth (pnm->pgm pnm) sigma)))
	(viff (create-image (pnm-height pgm) (pnm-width pgm))))
  (do ((y 0 (+ y 1))) ((>= y (pnm-height pgm)))
   (do ((x 0 (+ x 1))) ((>= x (pnm-width pgm)))
    (viff-set-pixel! viff y x (matrix-ref (pgm-grey pgm) y x))))
  ;; needs work: seuil, coef, and longmin are hardwired
  (detect-line-segments! a1 a2 t1 t2 l w viff)
  (let ((grey (make-matrix (pnm-height pgm) (pnm-width pgm))))
   (do ((y 0 (+ y 1))) ((>= y (pnm-height pgm)))
    (do ((x 0 (+ x 1))) ((>= x (pnm-width pgm)))
     (matrix-set! grey y x (edge-pixel viff y x))))
   (free-xvimage! viff)
   (make-pgm (pgm-raw? pgm) (pgm-maxval pgm) grey))))

(define (pnm->line-segments pnm sigma a1 a2 t1 t2 l w)
 (let* ((pgm (if (zero? sigma)
		 (pnm->pgm pnm)
		 (pgm-gaussian-smooth (pnm->pgm pnm) sigma)))
	(viff (create-image (pnm-height pgm) (pnm-width pgm))))
  (do ((y 0 (+ y 1))) ((>= y (pnm-height pgm)))
   (do ((x 0 (+ x 1))) ((>= x (pnm-width pgm)))
    (viff-set-pixel! viff y x (matrix-ref (pgm-grey pgm) y x))))
  ;; needs work: seuil, coef, and longmin are hardwired
  (detect-line-segments! a1 a2 t1 t2 l w viff)
  (let ((line-segments
	 (map-n (lambda (i)
		 (make-line-segment
		  (vector (line-segment-x1 i) (line-segment-y1 i))
		  (vector (line-segment-x2 i) (line-segment-y2 i))))
		(number-of-line-segments))))
   (free-xvimage! viff)
   line-segments)))

;;; Experimental stuff.

(define (pnm->pbm-edges pnm sigma a1 a2 t1 t2 l w)
 ;; Edge pixels are white (#T) in the result.
 (pgm->pbm (pnm->pgm-edges pnm sigma a1 a2 t1 t2 l w) 128))

;;; New Stuff

(define (pgm->image pgm)
 (map-vector (lambda (row) (map-vector exact->inexact row)) (pgm-grey pgm)))

(define (image->pgm image)
 (make-pgm
  #t
  *max-grey*
  (map-vector
   (lambda (row)
    (map-vector (lambda (element) (inexact->exact (floor element))) row))
   image)))

(define (image-filter-x! image filter)
 (let* ((ny (matrix-rows image))
	(nx (matrix-columns image))
	(nfilter (vector-length filter))
	(c (quotient nfilter 2))
	(row-copy (make-vector nx)))
  (do ((y 0 (+ y 1))) ((>= y ny))
   (do ((x 0 (+ x 1))) ((>= x nx))
    (vector-set! row-copy x (matrix-ref image y x)))
   (do ((x 0 (+ x 1))) ((>= x nx))
    (let ((s 0.0))
     (do ((fi 0 (+ fi 1))) ((>= fi nfilter))
      (let ((xi (+ (- x c) fi)))
       (when (and (>= xi 0) (< xi nx))
	(set! s (+ s (* (vector-ref row-copy xi) (vector-ref filter fi)))))))
     (matrix-set! image y x s))))))

(define (image-filter-y! image filter)
 (let* ((ny (matrix-rows image))
	(nx (matrix-columns image))
	(nfilter (vector-length filter))
	(c (quotient nfilter 2))
	(column-copy (make-vector ny)))
  (do ((x 0 (+ x 1))) ((>= x nx))
   (do ((y 0 (+ y 1))) ((>= y ny))
    (vector-set! column-copy y (matrix-ref image y x)))
   (do ((y 0 (+ y 1))) ((>= y ny))
    (let ((s 0.0))
     (do ((fi 0 (+ fi 1))) ((>= fi nfilter))
      (let ((yi (+ (- y c) fi)))
       (when (and (>= yi 0) (< yi ny))
	(set!
	 s (+ s (* (vector-ref column-copy yi) (vector-ref filter fi)))))))
     (matrix-set! image y x s))))))

(define (image-diff-x! image)
 (image-filter-x!
  image (vector (/ 12.0) (- (/ 2.0 3.0)) 0.0 (/ 2.0 3.0) (- (/ 12.0)))))

(define (image-diff-y! image)
 (image-filter-y!
  image (vector (/ 12.0) (- (/ 2.0 3.0)) 0.0 (/ 2.0 3.0) (- (/ 12.0)))))

(define (smooth-image! image sigma)
 (let* ((width 4.0)			; number of standard deviations to use
	(n (inexact->exact (ceiling (* width sigma))))
	(nfilter (+ (* 2 n) 1))
	(filter (make-vector nfilter))
	(k (/ 0.5 (sqr sigma)))
	(s 0.0))
  (do ((fi 0 (+ fi 1))) ((>= fi nfilter))
   (vector-set! filter fi (exp (- (* k (sqr (- fi n))))))
   (set! s (+ s (vector-ref filter fi))))
  ;; normalize filter so it sums to one
  (do ((fi 0 (+ fi 1))) ((>= fi nfilter))
   (vector-set! filter fi (/ (vector-ref filter fi) s)))
  (image-filter-x! image filter)
  (image-filter-y! image filter)))

(define (pgm-gaussian-smooth pgm sigma)
 (let ((image (pgm->image pgm)))
  (smooth-image! image sigma)
  (image->pgm image)))

;;; Stuff factored out of howard, leonard, and mjs.

(define (draw-strings-with-scroll-bar strings xmin xmax ymin ymax)
 ;; belongs in QobiScheme
 (let* ((visible-lines (quotient (- ymax ymin) *roman-height*))
	(first-line *first-line*)
	(last-line (min (+ *first-line* visible-lines) (length strings))))
  (unless (null? strings)
   (let* ((y1 ymin)
	  (y2 ymax)
	  (y3 (+ y1
		 (inexact->exact
		  (floor (* (- y2 y1) (/ *first-line* (length strings)))))))
	  (y4 (+ y1
		 (inexact->exact
		  (floor (* (- y2 y1) (/ last-line (length strings))))))))
    (xfillrectangle
     *display* *display-pane* *thin-gc* (+ xmax 4) y1 1 (- y2 y1))
    (xfillrectangle
     *display* *display-pane* *thin-gc* (+ xmax 2) y3 5 (- y4 y3))
    (define-region
     (+ xmax 2)
     y1
     5
     (- y2 y1)
     (lambda (x y)
      (set! *first-line*
	    (min (max 0 (- (length strings) visible-lines))
		 (quotient (* (length strings) (- y y1)) (- y2 y1))))
      (redraw-display-pane)))
    (define-region
     (+ xmax 2)
     y3
     5
     (- y4 y3)
     (lambda (x y5)
      (tracking-pointer
       #f
       #f
       (lambda (x y6)
	(set! *first-line*
	      (min (max 0 (- (length strings) visible-lines))
		   (max 0
			(+ first-line
			   (quotient
			    (* (length strings) (- y6 y5)) (- y2 y1))))))
	(redraw-display-pane)))))))
  (for-each-indexed (lambda (string i)
		     (xdrawstring *display* *display-pane* *roman-gc*
				  xmin (+ (* (+ i 1) *roman-height*) ymin)
				  string (string-length string)))
		    (sublist strings *first-line* last-line))))

;;; begin need change

(define (normalize-hue hue)
 (cond ((< hue 0) (normalize-hue (+ hue 360)))
       ((>= hue 360) (normalize-hue (- hue 360)))
       (else hue)))

(define (set-colour-range! camera alpha max-saturation-range p)
 (let ((hues '())
       (saturations '())
       (values '()))
  (do ((y1 (min (y *point*) (y *mark*)) (+ y1 1)))
    ((>= y1 (min (max (y *point*) (y *mark*)) *height*)))
   (do ((x1 (min (x *point*) (x *mark*)) (+ x1 1)))
     ((>= x1 (min (max (x *point*) (x *mark*)) *width*)))
    (let ((hsv (rgb->hsv (vector (hack-track-get-red camera 0 y1 x1)
				 (hack-track-get-green camera 0 y1 x1)
				 (hack-track-get-blue camera 0 y1 x1)))))
     (set! hues (cons (vector-ref hsv 0) hues))
     (set! saturations (cons (vector-ref hsv 1) saturations))
     (set! values (cons (vector-ref hsv 2) values)))))
  (let* ((n (length hues))
	 (target-hue (hue-mu hues))
	 (hues (sort hues
		     (lambda (hue1 hue2)
		      ((if (eq? (< hue1 180) (< hue2 180)) < >=)
		       hue1
		       hue2))
		     (lambda (hue) (- hue target-hue))))
	 (saturations (sort saturations < identity))
	 (values (sort values < identity))
	 (sh (list-ref
	      saturations
	      (min (inexact->exact (floor (* (- 1.0 alpha) n))) (- n 1)))))
   (p (list-ref hues (inexact->exact (floor (* alpha n))))
      (list-ref hues
		(min (inexact->exact (floor (* (- 1.0 alpha) n))) (- n 1)))
      ;; This is a kludge because many cameras, specifically the Philips 690
      ;; Vesta Pro Scan Webcam, give low saturation values.
      (max (list-ref saturations (inexact->exact (floor (* alpha n))))
	   (- sh max-saturation-range))
      sh
      (list-ref values (inexact->exact (floor (* alpha n))))
      (list-ref values
		(min (inexact->exact (floor (* (- 1.0 alpha) n))) (- n 1)))))))

(define (define-rgby-buttons
	 camera
	 red-x red-y green-x green-y blue-x blue-y yellow-x yellow-y
	 red?-x red?-y green?-x green?-y blue?-x blue?-y yellow?-x yellow?-y)
 (when (and red-x red-y)
  (define-button red-x red-y "Set Red" #f
   (lambda ()
    (let ((camera (if (procedure? camera) (camera) camera)))
     (message "")
     (unless (eq? *mode* 'viewfinder)
      (message "Can only do this in viewfinder mode")
      (abort))
     (unless *point* (message "No region") (abort))
     (set-colour-range!
      camera
      0.1
      15
      (lambda (hl hh sl sh vl vh)
       (vector-set! *red?* camera #t)
       (vector-set! *rhl* camera (normalize-hue (- hl *hue-stretch*)))
       (vector-set! *rhh* camera (normalize-hue (+ hh *hue-stretch*)))
       (vector-set! *rsl* camera (max (- sl *saturation-stretch*) 0))
       (vector-set! *rsh* camera (min (+ sh *saturation-stretch*) 100))
       (vector-set! *rvl* camera (max (- vl *value-stretch*) 0))
       (vector-set! *rvh* camera (min (+ vh *value-stretch*) 100))
       (hack-track-set-red-range! camera
				  (vector-ref *red?* camera)
				  (vector-ref *rhl* camera)
				  (vector-ref *rhh* camera)
				  (vector-ref *rsl* camera)
				  (vector-ref *rsh* camera)
				  (vector-ref *rvl* camera)
				  (vector-ref *rvh* camera))
       (redraw-buttons)))))))
 (when (and green-x green-y)
  (define-button green-x green-y "Set Green" #f
   (lambda ()
    (let ((camera (if (procedure? camera) (camera) camera)))
     (message "")
     (unless (eq? *mode* 'viewfinder)
      (message "Can only do this in viewfinder mode")
      (abort))
     (unless *point* (message "No region") (abort))
     (set-colour-range!
      camera
      0.1
      15
      (lambda (hl hh sl sh vl vh)
       (vector-set! *green?* camera #t)
       (vector-set! *ghl* camera (normalize-hue (- hl *hue-stretch*)))
       (vector-set! *ghh* camera (normalize-hue (+ hh *hue-stretch*)))
       (vector-set! *gsl* camera (max (- sl *saturation-stretch*) 0))
       (vector-set! *gsh* camera (min (+ sh *saturation-stretch*) 100))
       (vector-set! *gvl* camera (max (- vl *value-stretch*) 0))
       (vector-set! *gvh* camera (min (+ vh *value-stretch*) 100))
       (hack-track-set-green-range! camera
				    (vector-ref *green?* camera)
				    (vector-ref *ghl* camera)
				    (vector-ref *ghh* camera)
				    (vector-ref *gsl* camera)
				    (vector-ref *gsh* camera)
				    (vector-ref *gvl* camera)
				    (vector-ref *gvh* camera))
       (redraw-buttons)))))))
 (when (and blue-x blue-y)
  (define-button blue-x blue-y "Set Blue" #f
   (lambda ()
    (let ((camera (if (procedure? camera) (camera) camera)))
     (message "")
     (unless (eq? *mode* 'viewfinder)
      (message "Can only do this in viewfinder mode")
      (abort))
     (unless *point* (message "No region") (abort))
     (set-colour-range!
      camera
      0.1
      15
      (lambda (hl hh sl sh vl vh)
       (vector-set! *blue?* camera #t)
       (vector-set! *bhl* camera (normalize-hue (- hl *hue-stretch*)))
       (vector-set! *bhh* camera (normalize-hue (+ hh *hue-stretch*)))
       (vector-set! *bsl* camera (max (- sl *saturation-stretch*) 0))
       (vector-set! *bsh* camera (min (+ sh *saturation-stretch*) 100))
       (vector-set! *bvl* camera (max (- vl *value-stretch*) 0))
       (vector-set! *bvh* camera (min (+ vh *value-stretch*) 100))
       (hack-track-set-blue-range! camera
				   (vector-ref *blue?* camera)
				   (vector-ref *bhl* camera)
				   (vector-ref *bhh* camera)
				   (vector-ref *bsl* camera)
				   (vector-ref *bsh* camera)
				   (vector-ref *bvl* camera)
				   (vector-ref *bvh* camera))
       (redraw-buttons)))))))
 (when (and yellow-x yellow-y)
  (define-button yellow-x yellow-y "Set Yellow" #f
   (lambda ()
    (let ((camera (if (procedure? camera) (camera) camera)))
     (message "")
     (unless (eq? *mode* 'viewfinder)
      (message "Can only do this in viewfinder mode")
      (abort))
     (unless *point* (message "No region") (abort))
     (set-colour-range!
      camera
      0.1
      15
      (lambda (hl hh sl sh vl vh)
       (vector-set! *yellow?* camera #t)
       (vector-set! *yhl* camera (normalize-hue (- hl *hue-stretch*)))
       (vector-set! *yhh* camera (normalize-hue (+ hh *hue-stretch*)))
       (vector-set! *ysl* camera (max (- sl *saturation-stretch*) 0))
       (vector-set! *ysh* camera (min (+ sh *saturation-stretch*) 100))
       (vector-set! *yvl* camera (max (- vl *value-stretch*) 0))
       (vector-set! *yvh* camera (min (+ vh *value-stretch*) 100))
       (hack-track-set-yellow-range! camera
				     (vector-ref *yellow?* camera)
				     (vector-ref *yhl* camera)
				     (vector-ref *yhh* camera)
				     (vector-ref *ysl* camera)
				     (vector-ref *ysh* camera)
				     (vector-ref *yvl* camera)
				     (vector-ref *yvh* camera))
       (redraw-buttons)))))))
 (when (and red?-x red?-y)
  (define-button red?-x red?-y "Red"
   (lambda () (vector-ref *red?* (if (procedure? camera) (camera) camera)))
   (lambda ()
    (let ((camera (if (procedure? camera) (camera) camera)))
     (vector-set! *red?* camera (not (vector-ref *red?* camera)))
     (redraw-buttons)
     (hack-track-set-red-range! camera
				(vector-ref *red?* camera)
				(vector-ref *rhl* camera)
				(vector-ref *rhh* camera)
				(vector-ref *rsl* camera)
				(vector-ref *rsh* camera)
				(vector-ref *rvl* camera)
				(vector-ref *rvh* camera))))))
 (when (and green?-x green?-y)
  (define-button green?-x green?-y "Green"
   (lambda () (vector-ref *green?* (if (procedure? camera) (camera) camera)))
   (lambda ()
    (let ((camera (if (procedure? camera) (camera) camera)))
     (vector-set! *green?* camera (not (vector-ref *green?* camera)))
     (redraw-buttons)
     (hack-track-set-green-range! camera
				  (vector-ref *green?* camera)
				  (vector-ref *ghl* camera)
				  (vector-ref *ghh* camera)
				  (vector-ref *gsl* camera)
				  (vector-ref *gsh* camera)
				  (vector-ref *gvl* camera)
				  (vector-ref *gvh* camera))))))
 (when (and blue?-x blue?-y)
  (define-button blue?-x blue?-y "Blue"
   (lambda () (vector-ref *blue?* (if (procedure? camera) (camera) camera)))
   (lambda ()
    (let ((camera (if (procedure? camera) (camera) camera)))
     (vector-set! *blue?* camera (not (vector-ref *blue?* camera)))
     (redraw-buttons)
     (hack-track-set-blue-range! camera
				 (vector-ref *blue?* camera)
				 (vector-ref *bhl* camera)
				 (vector-ref *bhh* camera)
				 (vector-ref *bsl* camera)
				 (vector-ref *bsh* camera)
				 (vector-ref *bvl* camera)
				 (vector-ref *bvh* camera))))))
 (when (and yellow?-x yellow?-y)
  (define-button yellow?-x yellow?-y "Yellow"
   (lambda () (vector-ref *yellow?* (if (procedure? camera) (camera) camera)))
   (lambda ()
    (let ((camera (if (procedure? camera) (camera) camera)))
     (vector-set! *yellow?* camera (not (vector-ref *yellow?* camera)))
     (redraw-buttons)
     (hack-track-set-yellow-range! camera
				   (vector-ref *yellow?* camera)
				   (vector-ref *yhl* camera)
				   (vector-ref *yhh* camera)
				   (vector-ref *ysl* camera)
				   (vector-ref *ysh* camera)
				   (vector-ref *yvl* camera)
				   (vector-ref *yvh* camera)))))))

;;; end need change

(define (define-tracker-buttons
	 camera
	 m-down-x m-down-y m-up-x m-up-y
	 cpm-down-x cpm-down-y cpm-up-x cpm-up-y
	 cp-down-x cp-down-y cp-up-x cp-up-y
	 mpm-down-x mpm-down-y mpm-up-x mpm-up-y
	 mp-down-x mp-down-y mp-up-x mp-up-y )
 (define-button m-down-x m-down-y
  (lambda ()
   (format #f "-M ~s"
	   (vector-ref *hack-track-motion-threshold*
		       (if (procedure? camera) (camera) camera))))
  #f
  (lambda ()
   (let ((camera (if (procedure? camera) (camera) camera)))
    (unless (= (vector-ref *hack-track-motion-threshold* camera) 1)
     (vector-set! *hack-track-motion-threshold*
		  camera
		  (- (vector-ref *hack-track-motion-threshold* camera) 1))
     (redraw-buttons)
     (hack-track-set-thresholds!
      camera
      (vector-ref *hack-track-motion-threshold* camera)
      (vector-ref *hack-track-colour-pixel-mass-threshold* camera)
      (vector-ref *hack-track-colour-proximity-threshold* camera)
      (vector-ref *hack-track-motion-pixel-mass-threshold* camera)
      (vector-ref *hack-track-motion-proximity-threshold* camera))))))
 (define-button m-up-x m-up-y
  (lambda ()
   (format #f "+M ~s"
	   (vector-ref *hack-track-motion-threshold*
		       (if (procedure? camera) (camera) camera))))
  #f
  (lambda ()
   (let ((camera (if (procedure? camera) (camera) camera)))
    (unless (= (vector-ref *hack-track-motion-threshold* camera) 50)
     (vector-set! *hack-track-motion-threshold*
		  camera
		  (+ (vector-ref *hack-track-motion-threshold* camera) 1))
     (redraw-buttons)
     (hack-track-set-thresholds!
      camera
      (vector-ref *hack-track-motion-threshold* camera)
      (vector-ref *hack-track-colour-pixel-mass-threshold* camera)
      (vector-ref *hack-track-colour-proximity-threshold* camera)
      (vector-ref *hack-track-motion-pixel-mass-threshold* camera)
      (vector-ref *hack-track-motion-proximity-threshold* camera))))))
 (define-button cpm-down-x cpm-down-y
  (lambda ()
   (format #f "-CPM ~s"
	   (vector-ref *hack-track-colour-pixel-mass-threshold*
		       (if (procedure? camera) (camera) camera))))
  #f
  (lambda ()
   (let ((camera (if (procedure? camera) (camera) camera)))
    (unless (= (vector-ref *hack-track-colour-pixel-mass-threshold* camera) 1)
     (vector-set!
      *hack-track-colour-pixel-mass-threshold*
      camera
      (- (vector-ref *hack-track-colour-pixel-mass-threshold* camera) 1))
     (redraw-buttons)
     (hack-track-set-thresholds!
      camera
      (vector-ref *hack-track-motion-threshold* camera)
      (vector-ref *hack-track-colour-pixel-mass-threshold* camera)
      (vector-ref *hack-track-colour-proximity-threshold* camera)
      (vector-ref *hack-track-motion-pixel-mass-threshold* camera)
      (vector-ref *hack-track-motion-proximity-threshold* camera))))))
 (define-button cpm-up-x cpm-up-y
  (lambda ()
   (format #f "+CPM ~s"
	   (vector-ref *hack-track-colour-pixel-mass-threshold*
		       (if (procedure? camera) (camera) camera))))
  #f
  (lambda ()
   (let ((camera (if (procedure? camera) (camera) camera)))
    (unless (= (vector-ref *hack-track-colour-pixel-mass-threshold* camera)
	       300)
     (vector-set!
      *hack-track-colour-pixel-mass-threshold*
      camera
      (+ (vector-ref *hack-track-colour-pixel-mass-threshold* camera) 1))
     (redraw-buttons)
     (hack-track-set-thresholds!
      camera
      (vector-ref *hack-track-motion-threshold* camera)
      (vector-ref *hack-track-colour-pixel-mass-threshold* camera)
      (vector-ref *hack-track-colour-proximity-threshold* camera)
      (vector-ref *hack-track-motion-pixel-mass-threshold* camera)
      (vector-ref *hack-track-motion-proximity-threshold* camera))))))
 (define-button cp-down-x cp-down-y
  (lambda ()
   (format #f "-CP ~s"
	   (vector-ref *hack-track-colour-proximity-threshold*
		       (if (procedure? camera) (camera) camera))))
  #f
  (lambda ()
   (let ((camera (if (procedure? camera) (camera) camera)))
    (unless (= (vector-ref *hack-track-colour-proximity-threshold* camera) 2)
     (vector-set!
      *hack-track-colour-proximity-threshold*
      camera
      (- (vector-ref *hack-track-colour-proximity-threshold* camera) 2))
     (redraw-buttons)
     (hack-track-set-thresholds!
      camera
      (vector-ref *hack-track-motion-threshold* camera)
      (vector-ref *hack-track-colour-pixel-mass-threshold* camera)
      (vector-ref *hack-track-colour-proximity-threshold* camera)
      (vector-ref *hack-track-motion-pixel-mass-threshold* camera)
      (vector-ref *hack-track-motion-proximity-threshold* camera))))))
 (define-button cp-up-x cp-up-y
  (lambda ()
   (format #f "+CP ~s"
	   (vector-ref *hack-track-colour-proximity-threshold*
		       (if (procedure? camera) (camera) camera))))
  #f
  (lambda ()
   (let ((camera (if (procedure? camera) (camera) camera)))
    (unless (= (vector-ref *hack-track-colour-proximity-threshold* camera) 30)
     (vector-set!
      *hack-track-colour-proximity-threshold*
      camera
      (+ (vector-ref *hack-track-colour-proximity-threshold* camera) 2))
     (redraw-buttons)
     (hack-track-set-thresholds!
      camera
      (vector-ref *hack-track-motion-threshold* camera)
      (vector-ref *hack-track-colour-pixel-mass-threshold* camera)
      (vector-ref *hack-track-colour-proximity-threshold* camera)
      (vector-ref *hack-track-motion-pixel-mass-threshold* camera)
      (vector-ref *hack-track-motion-proximity-threshold* camera))))))
 (define-button mpm-down-x mpm-down-y
  (lambda ()
   (format #f "-MPM ~s"
	   (vector-ref *hack-track-motion-pixel-mass-threshold*
		       (if (procedure? camera) (camera) camera))))
  #f
  (lambda ()
   (let ((camera (if (procedure? camera) (camera) camera)))
    (unless (= (vector-ref *hack-track-motion-pixel-mass-threshold* camera) 1)
     (vector-set!
      *hack-track-motion-pixel-mass-threshold*
      camera
      (- (vector-ref *hack-track-motion-pixel-mass-threshold* camera) 1))
     (redraw-buttons)
     (hack-track-set-thresholds!
      camera
      (vector-ref *hack-track-motion-threshold* camera)
      (vector-ref *hack-track-colour-pixel-mass-threshold* camera)
      (vector-ref *hack-track-colour-proximity-threshold* camera)
      (vector-ref *hack-track-motion-pixel-mass-threshold* camera)
      (vector-ref *hack-track-motion-proximity-threshold* camera))))))
 (define-button mpm-up-x mpm-up-y
  (lambda ()
   (format #f "+MPM ~s"
	   (vector-ref *hack-track-motion-pixel-mass-threshold*
		       (if (procedure? camera) (camera) camera))))
  #f
  (lambda ()
   (let ((camera (if (procedure? camera) (camera) camera)))
    (unless (= (vector-ref *hack-track-motion-pixel-mass-threshold* camera)
	       300)
     (vector-set!
      *hack-track-motion-pixel-mass-threshold*
      camera
      (+ (vector-ref *hack-track-motion-pixel-mass-threshold* camera) 1))
     (redraw-buttons)
     (hack-track-set-thresholds!
      camera
      (vector-ref *hack-track-motion-threshold* camera)
      (vector-ref *hack-track-colour-pixel-mass-threshold* camera)
      (vector-ref *hack-track-colour-proximity-threshold* camera)
      (vector-ref *hack-track-motion-pixel-mass-threshold* camera)
      (vector-ref *hack-track-motion-proximity-threshold* camera))))))
 (define-button mp-down-x mp-down-y
  (lambda ()
   (format #f "-MP ~s"
	   (vector-ref *hack-track-motion-proximity-threshold*
		       (if (procedure? camera) (camera) camera))))
  #f
  (lambda ()
   (let ((camera (if (procedure? camera) (camera) camera)))
    (unless (= (vector-ref *hack-track-motion-proximity-threshold* camera) 2)
     (vector-set!
      *hack-track-motion-proximity-threshold*
      camera
      (- (vector-ref *hack-track-motion-proximity-threshold* camera) 2))
     (redraw-buttons)
     (hack-track-set-thresholds!
      camera
      (vector-ref *hack-track-motion-threshold* camera)
      (vector-ref *hack-track-colour-pixel-mass-threshold* camera)
      (vector-ref *hack-track-colour-proximity-threshold* camera)
      (vector-ref *hack-track-motion-pixel-mass-threshold* camera)
      (vector-ref *hack-track-motion-proximity-threshold* camera))))))
 (define-button mp-up-x mp-up-y
  (lambda ()
   (format #f "+MP ~s"
	   (vector-ref *hack-track-motion-proximity-threshold*
		       (if (procedure? camera) (camera) camera))))
  #f
  (lambda ()
   (let ((camera (if (procedure? camera) (camera) camera)))
    (unless (= (vector-ref *hack-track-motion-proximity-threshold* camera) 30)
     (vector-set!
      *hack-track-motion-proximity-threshold*
      camera
      (+ (vector-ref *hack-track-motion-proximity-threshold* camera) 2))
     (redraw-buttons)
     (hack-track-set-thresholds!
      camera
      (vector-ref *hack-track-motion-threshold* camera)
      (vector-ref *hack-track-colour-pixel-mass-threshold* camera)
      (vector-ref *hack-track-colour-proximity-threshold* camera)
      (vector-ref *hack-track-motion-pixel-mass-threshold* camera)
      (vector-ref *hack-track-motion-proximity-threshold* camera)))))))

;;; Tam V'Nishlam Shevah L'El Borei Olam
