/* LaHaShem HaAretz U'Mloah */
/* $Id: tool1lib-v4l-c.h,v 1.2 2008-11-13 18:42:47 qobi Exp $ */

#ifndef _TOOL1LIB_V4L_C_H
#define _TOOL1LIB_V4L_C_H

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <fcntl.h>
#include <string.h>
#include <unistd.h>
#include <malloc.h>
#include <sys/ioctl.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include <linux/videodev.h>
#include "ccvt.h"
#include "pwc-ioctl.h"

#ifndef TRUE
#define TRUE (0==0)
#endif

#ifndef FALSE
#define FALSE (0!=0)
#endif

#define NCAMERAS 4

/* Global Variables */

extern char v4l_video_device[NCAMERAS][100];
extern int v4l_fd[NCAMERAS];
extern int v4l_width[NCAMERAS], v4l_height[NCAMERAS], v4l_palette[NCAMERAS];
extern unsigned char *v4l_frame[NCAMERAS], *v4l_converted_frame[NCAMERAS];

/* Until ccvt is ported to x86_64 fall back to a C version */

#ifndef __i386__
int clamp(int v, int l, int u);
void yuvToBGRpixel(int y,
		   int u,
		   int v,
		   unsigned char* b,
		   unsigned char* g,
		   unsigned char* r);
void ccvt_420p_bgr32(const int width, const int height,
		     const unsigned char *srcy, const unsigned char *srcu,
		     const unsigned char *srcv, unsigned char *dst);
#endif

/* Function Prototypes */

void v4l_set_video_device(int camera, char *device);
int v4l_available(int camera);
void v4l_open_video(int camera);
void v4l_close_video(int camera);
void v4l_restore_factory_settings(int camera);
void v4l_save_user_settings(int camera);
void v4l_restore_user_settings(int camera);
int v4l_get_agc(int camera);
void v4l_set_agc(int camera, int agc);
void v4l_set_shutter(int camera, int shutter);
int v4l_get_compression(int camera);
void v4l_set_compression(int camera, int compression);
int v4l_get_palette(int camera);
void v4l_set_palette(int camera, int palette, int depth);
int v4l_get_brightness(int camera);
void v4l_set_brightness(int camera, int brightness);
int v4l_get_contrast(int camera);
void v4l_set_contrast(int camera, int contrast);
int v4l_get_hue(int camera);
void v4l_set_hue(int camera, int hue);
int v4l_get_colour(int camera);
void v4l_set_colour(int camera, int colour);
int v4l_get_whiteness(int camera);
void v4l_set_whiteness(int camera, int whiteness);
int v4l_get_width(int camera);
int v4l_get_height(int camera);
void v4l_set_size(int camera, int width, int height);
int v4l_get_frame_rate(int camera);
void v4l_set_frame_rate(int camera, int frame_rate, int snap);
int v4l_get_maxwidth(int camera);
int v4l_get_maxheight(int camera);
int v4l_get_minwidth(int camera);
int v4l_get_minheight(int camera);
int v4l_get_channels(int camera);
char *v4l_get_name(int camera);
void v4l_allocate_frame(int camera);
void v4l_free_frame(int camera);
int v4l_frame_available(int camera);
void v4l_get_frame(int camera);
void v4l_mmap_frame(int camera);
void v4l_munmap_frame(int camera);
int v4l_get_number_of_mmaped_frames(int camera);
void v4l_mmap_capture(int camera, int frame);
void v4l_mmap_sync(int camera, int frame);
void v4l_mmap_get_frame(int camera);
void v4l_interrupt_on(int frame_rate);
void v4l_interrupt_off(void);
void v4l_write_ppm(int camera, char *name);
void v4l_home(int camera, int tilt, int pan);
int v4l_get_pan_min(int camera);
int v4l_get_pan_max(int camera);
int v4l_get_tilt_min(int camera);
int v4l_get_tilt_max(int camera);
int v4l_get_pan(int camera);
int v4l_get_tilt(int camera);
void v4l_set_pan_tilt(int camera, int pan, int tilt, int absolute);
int v4l_pan_tilt_status(int camera);
#endif

/* Tam V'Nishlam Shevah L'El Borei Olam */
